package hello;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import org.springframework.amqp.core.Queue;
import org.springframework.amqp.rabbit.core.RabbitTemplate;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Scheduled;

import org.apache.logging.log4j.Logger;
import org.apache.logging.log4j.LogManager;

import hello.User;
import hello.UserRepository;

@Controller    // This means that this class is a Controller
@RequestMapping(path="/users") // This means URL's start with /demo (after Application path)
public class MainController {

    Logger logger = LogManager.getLogger(MainController.class);

	@Autowired // This means to get the bean called userRepository
	           // Which is auto-generated by Spring, we will use it to handle the data
    private UserRepository userRepository;
    
    @Autowired
    private RabbitTemplate template;
	
	@PostMapping //
    public @ResponseBody String addNewUser (@RequestParam String name, 
                                            @RequestParam String email) {
		// @ResponseBody means the returned String is the response, not a view name
		// @RequestParam means it is a parameter from the GET or POST request
		
		User n = new User();
		n.setName(name);
		n.setEmail(email);
		userRepository.save(n);

        send_message();

		return "Saved";
	}
	
	@GetMapping
	public @ResponseBody Iterable<User> getAllUsers() {
        logger.info("in getAllUsers");
		// This returns a JSON or XML with the users
		return userRepository.findAll();
    }
    
    public void send_message() {
        logger.info("sending message to rabbitmq...");
        String message = "Hello World From java Service!";
        this.template.convertAndSend("my_queue", message);
        System.out.println(" [x] Sent '" + message + "'");
    }
}
